hpp-core: hpp::core::pathPlanner::kPrmStar Class Reference

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
hpp::core::pathPlanner::kPrmStar Class Reference
Path planning algorithms

`#include <hpp/core/path-planner/k-prm-star.hh>`

Inheritance diagram for hpp::core::pathPlanner::kPrmStar:
[legend]
Collaboration diagram for hpp::core::pathPlanner::kPrmStar:
[legend]

## Public Types
enum | STATE { BUILD_ROADMAP , LINK_NODES , CONNECT_INIT_GOAL , FAILURE }
| Computation step of the algorithm. More...
typedef PathPlanner | Parent_t

## Public Member Functions
virtual void | startSolve ()
virtual void | tryConnectInitAndGoals ()
virtual void | oneStep ()
| One step of the algorithm.
STATE | getComputationState () const
| get the computationnal state of the algorithm
Public Member Functions inherited from hpp::core::PathPlanner
virtual | ~PathPlanner ()
virtual const RoadmapPtr_t & | roadmap () const
| Get roadmap.
ProblemConstPtr_t | problem () const
| Get problem.
virtual PathVectorPtr_t | solve ()
virtual PathVectorPtr_t | finishSolve (const PathVectorPtr_t &path)
| Post processing of the resulting path.
void | interrupt ()
| Interrupt path planning.
void | maxIterations (const unsigned long int &n)
| Set maximal number of iterations.
unsigned long int | maxIterations () const
| Get maximal number of iterations.
void | timeOut (const double &timeOut)
| set time out (in seconds)
double | timeOut () const
| Get time out.
void | stopWhenProblemIsSolved (bool enable)
PathVectorPtr_t | computePath () const
| Find a path in the roadmap and transform it in trajectory.

## Static Public Member Functions
static kPrmStarPtr_t | create (const ProblemConstPtr_t &problem)
static kPrmStarPtr_t | createWithRoadmap (const ProblemConstPtr_t &problem, const RoadmapPtr_t &roadmap)

## Static Public Attributes
static const double | kPRM
| Constant kPRM = 2 e.

## Protected Member Functions
| kPrmStar (const ProblemConstPtr_t &problem)
| kPrmStar (const ProblemConstPtr_t &problem, const RoadmapPtr_t &roadmap)
void | init (const kPrmStarWkPtr_t &weak)
| Store weak pointer to itself.
Protected Member Functions inherited from hpp::core::PathPlanner
| PathPlanner (const ProblemConstPtr_t &problem)
| PathPlanner (const ProblemConstPtr_t &problem, const RoadmapPtr_t &roadmap)
void | init (const PathPlannerWkPtr_t &weak)
| Store weak pointer to itself.

## Detailed Description

k-PRM* path planning algorithm as described in https://arxiv.org/pdf/1105.1186.pdf.

## Member Typedef Documentation

## ◆ Parent_t

typedef PathPlanner hpp::core::pathPlanner::kPrmStar::Parent_t

## Member Enumeration Documentation

## ◆ STATE

enum hpp::core::pathPlanner::kPrmStar::STATE

Computation step of the algorithm.

Enumerator
BUILD_ROADMAP |
LINK_NODES |
CONNECT_INIT_GOAL |
FAILURE |

## Constructor & Destructor Documentation

## ◆ kPrmStar() [1/2]

hpp::core::pathPlanner::kPrmStar::kPrmStar | ( | const ProblemConstPtr_t & | problem | ) |
| protected

Protected constructor

Parameters

  problem | the path planning problem

## ◆ kPrmStar() [2/2]

hpp::core::pathPlanner::kPrmStar::kPrmStar | ( | const ProblemConstPtr_t & | problem,
|  | const RoadmapPtr_t & | roadmap
| ) |  |
| protected

Protected constructor

Parameters

  problem | the path planning problem
  roadmap | previously built roadmap

## Member Function Documentation

## ◆ create()

static kPrmStarPtr_t hpp::core::pathPlanner::kPrmStar::create | ( | const ProblemConstPtr_t & | problem | ) |
| static

Return shared pointer to new instance

Parameters

  problem | the path planning problem

## ◆ createWithRoadmap()

static kPrmStarPtr_t hpp::core::pathPlanner::kPrmStar::createWithRoadmap | ( | const ProblemConstPtr_t & | problem,
|  | const RoadmapPtr_t & | roadmap
| ) |  |
| static

Return shared pointer to new instance

Parameters

  problem | the path planning problem
  roadmap | previously built roadmap

## ◆ getComputationState()

STATE hpp::core::pathPlanner::kPrmStar::getComputationState | ( |  | ) | const

get the computationnal state of the algorithm

## ◆ init()

void hpp::core::pathPlanner::kPrmStar::init | ( | const kPrmStarWkPtr_t & | weak | ) |
| protected

Store weak pointer to itself.

## ◆ oneStep()

virtual void hpp::core::pathPlanner::kPrmStar::oneStep | ( |  | ) |
| virtual

One step of the algorithm.

Implements hpp::core::PathPlanner.

## ◆ startSolve()

virtual void hpp::core::pathPlanner::kPrmStar::startSolve | ( |  | ) |
| virtual

Initialize the problem resolution

- call parent implementation
- get number nodes in problem parameter map

Reimplemented from hpp::core::PathPlanner.

## ◆ tryConnectInitAndGoals()

virtual void hpp::core::pathPlanner::kPrmStar::tryConnectInitAndGoals | ( |  | ) |
| virtual

Does nothing. This step is performed by the main algorithm

Reimplemented from hpp::core::PathPlanner.

## Member Data Documentation

## ◆ kPRM

const double hpp::core::pathPlanner::kPrmStar::kPRM
| static

Constant kPRM = 2 e.

The documentation for this class was generated from the following file:

- include/hpp/core/path-planner/k-prm-star.hh